/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var CatalogInfoResponseLimits = require('./CatalogInfoResponseLimits');
var Error = require('./Error');
var StandardUnitDescriptionGroup = require('./StandardUnitDescriptionGroup');




/**
 * The CatalogInfoResponse model module.
 * @module model/CatalogInfoResponse
 */

/**
 * Constructs a new <code>CatalogInfoResponse</code>.
 * 
 * @alias module:model/CatalogInfoResponse
 * @class
 */
var exports = function() {
  var _this = this;




};

/**
 * Constructs a <code>CatalogInfoResponse</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/CatalogInfoResponse} obj Optional instance to populate.
 * @return {module:model/CatalogInfoResponse} The populated <code>CatalogInfoResponse</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('errors')) {
      obj['errors'] = ApiClient.convertToType(data['errors'], [Error]);
    }
      if (data.hasOwnProperty('limits')) {
      obj['limits'] = CatalogInfoResponseLimits.constructFromObject(data['limits']);
    }
      if (data.hasOwnProperty('standard_unit_description_group')) {
      obj['standard_unit_description_group'] = StandardUnitDescriptionGroup.constructFromObject(data['standard_unit_description_group']);
    }
    }
  return obj;
}

/**
 * The set of errors encountered.
 * @member {Array.<module:model/Error>} errors
 */
exports.prototype['errors'] = undefined;
/**
 * 
 * @member {module:model/CatalogInfoResponseLimits} limits
 */
exports.prototype['limits'] = undefined;
/**
 * Names and abbreviations for standard units.
 * @member {module:model/StandardUnitDescriptionGroup} standard_unit_description_group
 */
exports.prototype['standard_unit_description_group'] = undefined;



module.exports = exports;



