/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The CatalogQueryItemsForModifierList model module.
 * @module model/CatalogQueryItemsForModifierList
 */

/**
 * Constructs a new <code>CatalogQueryItemsForModifierList</code>.
 * 
 * @alias module:model/CatalogQueryItemsForModifierList
 * @class
 * @param modifierListIds {Array.<String>} A set of `CatalogModifierList` IDs to be used to find associated `CatalogItem`s.
 */
var exports = function(modifierListIds) {
  var _this = this;

  _this['modifier_list_ids'] = modifierListIds;
};

/**
 * Constructs a <code>CatalogQueryItemsForModifierList</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/CatalogQueryItemsForModifierList} obj Optional instance to populate.
 * @return {module:model/CatalogQueryItemsForModifierList} The populated <code>CatalogQueryItemsForModifierList</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('modifier_list_ids')) {
      obj['modifier_list_ids'] = ApiClient.convertToType(data['modifier_list_ids'], ['String']);
    }
    }
  return obj;
}

/**
 * A set of `CatalogModifierList` IDs to be used to find associated `CatalogItem`s.
 * @member {Array.<String>} modifier_list_ids
 */
exports.prototype['modifier_list_ids'] = undefined;



module.exports = exports;



