/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The LoyaltyEventOrderFilter model module.
 * Note: This model is in beta.
 * @module model/LoyaltyEventOrderFilter
 */

/**
 * Constructs a new <code>LoyaltyEventOrderFilter</code>.
 * Filter events by the order associated with the event.
 * @alias module:model/LoyaltyEventOrderFilter
 * @class
 * @param orderId {String} The ID of the `order` associated with the event.
 */
var exports = function(orderId) {
  var _this = this;

  _this['order_id'] = orderId;
};

/**
 * Constructs a <code>LoyaltyEventOrderFilter</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/LoyaltyEventOrderFilter} obj Optional instance to populate.
 * @return {module:model/LoyaltyEventOrderFilter} The populated <code>LoyaltyEventOrderFilter</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('order_id')) {
      obj['order_id'] = ApiClient.convertToType(data['order_id'], 'String');
    }
    }
  return obj;
}

/**
 * The ID of the `order` associated with the event.
 * @member {String} order_id
 */
exports.prototype['order_id'] = undefined;



module.exports = exports;



