/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The LoyaltyEventTypeFilter model module.
 * Note: This model is in beta.
 * @module model/LoyaltyEventTypeFilter
 */

/**
 * Constructs a new <code>LoyaltyEventTypeFilter</code>.
 * Filter events by event type.
 * @alias module:model/LoyaltyEventTypeFilter
 * @class
 * @param types {Array.<String>} The loyalty event types used to filter the result. If multiple values are specified, the endpoint uses a  logical OR to combine them. See [LoyaltyEventType](#type-loyaltyeventtype) for possible values
 */
var exports = function(types) {
  var _this = this;

  _this['types'] = types;
};

/**
 * Constructs a <code>LoyaltyEventTypeFilter</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/LoyaltyEventTypeFilter} obj Optional instance to populate.
 * @return {module:model/LoyaltyEventTypeFilter} The populated <code>LoyaltyEventTypeFilter</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('types')) {
      obj['types'] = ApiClient.convertToType(data['types'], ['String']);
    }
    }
  return obj;
}

/**
 * The loyalty event types used to filter the result. If multiple values are specified, the endpoint uses a  logical OR to combine them. See [LoyaltyEventType](#type-loyaltyeventtype) for possible values
 * @member {Array.<String>} types
 */
exports.prototype['types'] = undefined;



module.exports = exports;



