/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');




/**
 * The LoyaltyProgramExpirationPolicy model module.
 * Note: This model is in beta.
 * @module model/LoyaltyProgramExpirationPolicy
 */

/**
 * Constructs a new <code>LoyaltyProgramExpirationPolicy</code>.
 * Describes when the loyalty program expires.
 * @alias module:model/LoyaltyProgramExpirationPolicy
 * @class
 * @param expirationDuration {String} The duration of time before points expire, in RFC 3339 format.
 */
var exports = function(expirationDuration) {
  var _this = this;

  _this['expiration_duration'] = expirationDuration;
};

/**
 * Constructs a <code>LoyaltyProgramExpirationPolicy</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/LoyaltyProgramExpirationPolicy} obj Optional instance to populate.
 * @return {module:model/LoyaltyProgramExpirationPolicy} The populated <code>LoyaltyProgramExpirationPolicy</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('expiration_duration')) {
      obj['expiration_duration'] = ApiClient.convertToType(data['expiration_duration'], 'String');
    }
    }
  return obj;
}

/**
 * The duration of time before points expire, in RFC 3339 format.
 * @member {String} expiration_duration
 */
exports.prototype['expiration_duration'] = undefined;



module.exports = exports;



