/**
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 */
var ApiClient = require('../ApiClient');
var JobAssignment = require('./JobAssignment');




/**
 * The WageSetting model module.
 * @module model/WageSetting
 */

/**
 * Constructs a new <code>WageSetting</code>.
 * An object representing a team member&#39;s wage information.
 * @alias module:model/WageSetting
 * @class
 */
var exports = function() {
  var _this = this;







};

/**
 * Constructs a <code>WageSetting</code> from a plain JavaScript object, optionally creating a new instance.
 * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
 * @param {Object} data The plain JavaScript object bearing properties of interest.
 * @param {module:model/WageSetting} obj Optional instance to populate.
 * @return {module:model/WageSetting} The populated <code>WageSetting</code> instance.
 */
exports.constructFromObject = function(data, obj) {
  if (data) {
    obj = obj || new exports();

      if (data.hasOwnProperty('team_member_id')) {
      obj['team_member_id'] = ApiClient.convertToType(data['team_member_id'], 'String');
    }
      if (data.hasOwnProperty('job_assignments')) {
      obj['job_assignments'] = ApiClient.convertToType(data['job_assignments'], [JobAssignment]);
    }
      if (data.hasOwnProperty('is_overtime_exempt')) {
      obj['is_overtime_exempt'] = ApiClient.convertToType(data['is_overtime_exempt'], 'Boolean');
    }
      if (data.hasOwnProperty('version')) {
      obj['version'] = ApiClient.convertToType(data['version'], 'Number');
    }
      if (data.hasOwnProperty('created_at')) {
      obj['created_at'] = ApiClient.convertToType(data['created_at'], 'String');
    }
      if (data.hasOwnProperty('updated_at')) {
      obj['updated_at'] = ApiClient.convertToType(data['updated_at'], 'String');
    }
    }
  return obj;
}

/**
 * The unique ID of the `TeamMember` whom this wage setting describes.
 * @member {String} team_member_id
 */
exports.prototype['team_member_id'] = undefined;
/**
 * <b>Required</b> The ordered list of jobs that the team member is assigned to. The first job assignment is considered the team member's \"Primary Job\". <br> <b>Min Length 1    Max Length 12</b>
 * @member {Array.<module:model/JobAssignment>} job_assignments
 */
exports.prototype['job_assignments'] = undefined;
/**
 * Whether the team member is exempt from the overtime rules of the seller country.
 * @member {Boolean} is_overtime_exempt
 */
exports.prototype['is_overtime_exempt'] = undefined;
/**
 * Used for resolving concurrency issues; request will fail if version provided does not match server version at time of request. If not provided, Square executes a blind write, potentially overwriting data from another write. Read about [optimistic concurrency](https://developer.squareup.com/docs/docs/working-with-apis/optimistic-concurrency) in Square APIs for more information.
 * @member {Number} version
 */
exports.prototype['version'] = undefined;
/**
 * The timestamp in RFC 3339 format describing when the wage setting object was created. Ex: \"2018-10-04T04:00:00-07:00\" or \"2019-02-05T12:00:00Z\"
 * @member {String} created_at
 */
exports.prototype['created_at'] = undefined;
/**
 * The timestamp in RFC 3339 format describing when the wage setting object was last updated. Ex: \"2018-10-04T04:00:00-07:00\" or \"2019-02-05T12:00:00Z\"
 * @member {String} updated_at
 */
exports.prototype['updated_at'] = undefined;



module.exports = exports;



